package br.com.api.task;

import java.util.List;

import org.drools.runtime.StatefulKnowledgeSession;
import org.jbpm.process.workitem.wsht.AsyncGenericHTWorkItemHandler;
import org.jbpm.process.workitem.wsht.AsyncHornetQHTWorkItemHandler;
import org.jbpm.task.Content;
import org.jbpm.task.Status;
import org.jbpm.task.Task;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.ContentData;
import org.jbpm.task.service.FaultData;
import org.jbpm.task.service.TaskClient;

public interface EasyPieLocalTaskServiceInterface {

	// métodos de LocalTaskService

	void claim(long taskId, String userId);

	void claimNextAvailable(String userId, String language);

	void complete(long taskId, String userId, ContentData outputData);

	void completeWithResults(long taskId, String userId, Object results);

	AsyncGenericHTWorkItemHandler createTaskHandler(StatefulKnowledgeSession ksession, TaskClient client);

	void delegate(long taskId, String userId, String targetUserId);

	void exit(long taskId, String userId);

	void fail(long taskId, String userId, FaultData faultData);

	void forward(long taskId, String userId, String targetEntityId);

	public Content getContent(long contentId);

	public Task getTask(long taskId);

	public Task getTaskByWorkItemId(long workItemId);

	public List<TaskSummary> getTasksAssignedAsPotentialOwner(String userId, String language);

	public List<TaskSummary> getTasksAssignedAsPotentialOwnerByStatus(String userId, List<Status> status, String language);

	public List<TaskSummary> getTasksByStatusByProcessId(long processInstanceId, List<Status> status, String language);

	public List<TaskSummary> getTasksByStatusByProcessIdByTaskName(long processInstanceId, List<Status> status, String taskName, String language);

	public List<TaskSummary> getTasksOwned(String userId, List<Status> status, String language);

	public List<TaskSummary> getTasksOwned(String userId, String language);

	void release(long taskId, String userId);

	void remove(long taskId, String userId);

	void resume(long taskId, String userId);

	void skip(long taskId, String userId);

	void start(long taskId, String userId);

	void stop(long taskId, String userId);

	void suspend(long taskId, String userId);
	
}
